PROGRAM PRZ5_3;
  {$IFDEF CPU87} {$N+}
         {$ELSE} {$N-}
  {$ENDIF}
  USES CRT,GRAPH,TFLOAT,ALGELIN,RORONLD,WYKRESY,KOM_BLAD;
  VAR  X0        :WEK;
       W0,Wa,Wb  :WEKI;
       i,M       :WORD;
       N         :BYTE;
       h,h0,t0,t1,t,R1,R2,R0,Lr1,Lr2,L0,C,beta,Em,om1,
       Sfe,Lfe,w1,w2,w1k,w2k,teta,teta2,delta,mi0,
       Rdelta,a1,a2 :FLOAT;
       WYB          :CHAR;
       XX           :MACD3;
       BLAD         :BYTE;

  PROCEDURE DANE;
    BEGIN
      w1:=114;  Sfe:=11.05E-3; Lfe:=1.77;
      delta:=0.4E-3; mi0:=0.4*PI*1E-6; Rdelta:=delta/(mi0*Sfe);
      teta:=380/6300; teta2:=SQR(teta); R1:=0.5; R2:=R1/teta2;
      w2:=w1/teta ; w1k:=SQR(w1); w2k:=SQR(w2);
      om1:=100*PI;  Lr1:=0.5/om1; Lr2:=Lr1/teta2;
      R0:=2000; L0:=2000/om1; C:=1/(5000*om1);
      Em:=380.0*SQRT(2); beta:=PI/4;
      {Parametry charakterystyki magnesowania }
      a1:=0.2388293024; a2:=2.0567441597;
      t1:=0.2; N:=4 ; t0:=0.0;  h0:=(t1-t0)/512;
      X0[1]:=0.0; X0[2]:=0 ; X0[3]:=0.0; X0[4]:=0.0;
    END { DANE };

   FUNCTION SINH(X:FLOAT):FLOAT;
    VAR Y:FLOAT;
    BEGIN
      Y:=EXP(X);
      SINH:=0.5*(Y-1/Y)
    END;

   FUNCTION COSH(X:FLOAT):FLOAT;
    VAR Y:FLOAT;
    BEGIN
      Y:=EXP(X);
      COSH:=0.5*(Y+1/Y)
    END;

   FUNCTION E1(t:FLOAT):FLOAT;
     VAR  A:FLOAT;
     BEGIN
       E1:=Em*SIN(om1*t+beta)
     END {E};

   FUNCTION Umfe(Fi:FLOAT):FLOAT;  { wzor (1.164) }
     BEGIN
       Umfe:=Lfe/a2*SINH(Fi/(a1*Sfe))
     END {Umfe};

   FUNCTION Rmfe(Fi:FLOAT):FLOAT; { wzor (1.168) }
     BEGIN
       Rmfe:=Lfe/(a1*a2*Sfe)*COSH(Fi/(a1*Sfe))
     END {Rmfe};

   FUNCTION i2(i1,Fi:FLOAT):FLOAT; { wzor (1.166) }
     BEGIN
       i2:=(i1*w1-Fi*Rdelta-Umfe(Fi))/w2
     END {i2};

   PROCEDURE F(VAR F:WEK; X:WEK; t:FLOAT;N:BYTE); FAR;
   {    Prawe strony ukladu rownan (1.172)   gdzie    }
   { X[1]=i1(t) , X[2]=Fi(t) , X[3]=i0(t), X[4]=uc(t) }
     VAR detM,M11,M22,M12,M21,u1,u2,ii2,Rmfe1:FLOAT;
     BEGIN
       ii2:=i2(X[1],X[2]); Rmfe1:=Rmfe(X[2]);
       M11:=Lr2*(Rdelta+Rmfe1)/w2+w2; M22:=Lr1;
       M12:=-w1; M21:=w1*Lr2/w2;
       detM:=M11*M22-M12*M21;
       u2:=X[4]+R2*ii2; u1:=E1(t)-R1*X[1];
       F[1]:=(M11*u1+M12*u2)/detM;
       F[2]:=(M21*u1+M22*u2)/detM;
       F[3]:=(-R0*X[3]+X[4])/L0;
       F[4]:=(ii2-X[3])/C
     END {F};

   PROCEDURE MENU;
     BEGIN
      CLRSCR;
      GOTOXY(1, 5);  WRITE('    Przebiegi poszczegolnych wielkosci');
      GOTOXY(5, 7);  WRITE('klawisz  1 - pradu zasilania transformatora');
      GOTOXY(5, 9);  WRITE('         2 - pradu obciazenia transformatora');
      GOTOXY(5,11);  WRITE('         0 - pradu odbiornika ');
      GOTOXY(5,13);  WRITE('         C - napiecie na kondesatorze kompensacyjnym');
      GOTOXY(5,15);  WRITE('         M - pradu magnesujacego transformatora');
      GOTOXY(5,17);  WRITE('         F - strumienia glownego transformatora');
      GOTOXY(5,19);  WRITE('         B - charakterystyka magnesowania');
      GOTOXY(5,21);  WRITE('         K - koniec wyboru')
    END { MENU };

BEGIN  {Czesc operacyjna programu}
  CLRSCR;
  DANE;
  WRITE('M=');
  MET_FEHLB(2,4,N,F,h0,t0,t1,1e-5,1e-10,1E-5,X0,M,XX,BLAD,5*256+1);
  IF BLAD<>0
    THEN PISZ_KOM_BLAD(BLAD)
    ELSE BEGIN
           FOR i:=0 TO M DO
             W0[i]:=XX[i]^[0]*1000;
           REPEAT
             CLRSCR;
             MENU;
             WYB:=UPCASE(READKEY);
             CASE WYB OF
               '1': BEGIN
                      FOR i:=0 TO M DO
                        Wa[i]:=XX[i]^[1];
                      WYKRESXYG(W0,Wa,M,
                                'Rys.1 Przebieg pradu zasilania transformatora',
                                '','t [msek]','i1(t) [A]')
                    END { 1 };
                'F': BEGIN
                       FOR i:=0 TO M DO
                         Wa[i]:=XX[i]^[2];
                       WYKRESXYG(W0,Wa,M,
                                 'Rys.3 Przebieg strumienia glownego transformatora ',
                                 '','t [msek]','Fi(t) [Vs]')
                     END { F };
                '0': BEGIN
                       FOR i:=0 TO M DO
                         Wa[i]:=XX[i]^[3];
                       WYKRESXYG(W0,Wa,M,'Rys.4 Przebieg pradu odbiornika ',
                                 '','t [msek]','i0(t) [A]')
                     END { 0 };
                'C': BEGIN
                       FOR i:=0 TO M DO
                         Wa[i]:=XX[i]^[4];
                       WYKRESXYG(W0,Wa,M,'Rys.5 Przebieg napiecia na kondensatorze ',
                                          '','t [msek]','uc(t) [V]')
                     END { C };
                '2': BEGIN
                       FOR i:=0 TO M DO
                         Wa[i]:=i2(XX[i]^[1],XX[i]^[2]);
                       WYKRESXYG(W0,Wa,M,'Rys.2 Przebieg pradu obciazenia transformatora',
                                 '','t [msek]','i2(t) [A]')
                     END { 2 };
                'M': BEGIN
                       FOR i:=0 TO M DO
                         Wa[i]:=(XX[i]^[2]*Rdelta+Umfe(XX[i]^[2]))/w1;
                       WYKRESXYG(W0,Wa,M,'Rys.6 Przebieg pradu magnesujacego transformatora',
                                          '','t [msek]','imi(t) [A]')
                     END { M };
                'B': BEGIN
                       FOR i:=0 TO M DO
                       BEGIN
                         Wb[i]:=XX[i]^[2]*Rdelta+Umfe(XX[i]^[2]);
                         Wa[i]:=XX[i]^[2]/Sfe
                       END;
                       WYKRESXYG(Wb,Wa,M,'Rys.7 Charakterystyka magnesowania transformatora',
                                 '','imi*w1 [A]','B [Vs/m2]')
                    END { B }
               END
             UNTIL WYB='K'
        END;
  DISMACD3(XX,M)

END.


