PROGRAM PRZ5_5;
  {$IFDEF CPU87} {$N+}
         {$ELSE} {$N-}
  {$ENDIF}
  USES CRT,GRAPH,TFLOAT,ALGELIN,RORONLP,WYKRESY,PLIK_ZO,KOM_BLAD;
  VAR  X0                                        :WEK;
       G                                         :MAC;
       W1,W2,W3                                  :WEKI;
       M,i                                       :WORD;
       N                                         :BYTE;
       s,h0,TX,t0,t1,t,X,X1,X2,X3,c1,c2,c3,c4,
       wh,Usm,Uw,w0,be,fi0,p,Lrs,Ls,Ms,Lrw,Mw,
       Lw,Mws,MM,Lrk,Mk,Lk,MM1,Mwk,Msk,Rs,Rw,
       Rk,J,U,Mnap                               :FLOAT;
       WYB,CH,CH1                                :CHAR;
       N_PLIK                                    :DANE_NAZWY_PLIKU;
       BLAD                                      :BYTE;


  PROCEDURE DANE;
    VAR c,ga,al:FLOAT;
    BEGIN
      Usm:=9104*SQRT(2) {V}; Uw:=120 {V};
      w0:=100*PI; be:=PI/2;
      p:=1; { liczba par biegunow }
      Lrs:=0.00054; Ms:=0.00384 {H};
      Lrw:=0.053; Mw:=0.4887 {H};  Mws:=0.04332 {H};
      Lrk:=0.01059;  Mk:=Mw;  Mwk:=Mw; Msk:=Mws;
      Rs:=0.001947 {OM}; Rw:=0.109 {OM}; Rk:=0.27167;
      J:=40000 {kg m2};  wh:=0.000;
      Mnap:=10000 {Nm};
    END { DANE };

  PROCEDURE OBLICZENIA_POMOCNICZE ; { wedlug wzorow (5.207) }
    VAR det1,det2 :FLOAT;
        k,l       :BYTE;
    BEGIN
      U:=Usm*SQRT(3/2);
      Ls:=Lrs+1.5*Ms;  Lw:=Lrw+Mw;  Lk:=Lrk+Mk;
      MM:=Mws*SQRT(3/2);  MM1:=Msk*SQRT(3/2);
      { Generacja macierzy (5.206) }
      det1:=Ls*Lw*Lk+2*MM*Mwk*MM1-Lw*SQR(MM1)-Ls*SQR(Mwk)-Lk*SQR(MM);
      det2:=Ls*Lk-SQR(MM1);
      MACZERO(G,5,5);
      G[1,1]:=(Lw*Lk-SQR(Mwk))/det1;
      G[1,3]:=(Mwk*MM1-Lk*MM)/det1;
      G[1,4]:=(MM*Mwk-Lw*MM1)/det1;
      G[2,2]:=Lk/det2;
      G[2,5]:=-MM1/det2;
      G[5,2]:=G[2,5];
      G[3,1]:=G[1,3];
      G[3,3]:=(Ls*Lk-SQR(MM1))/det1;
      G[3,4]:=(MM*MM1-Ls*Mwk)/det1;
      G[4,1]:=G[1,4];
      G[4,3]:=G[3,4];
      G[4,4]:=(Ls*Lw-SQR(MM))/det1;
      G[5,5]:=Ls/det2;
      c2:=wh/J; c1:=p*MM/J;  c3:=1/J; c4:=p*MM1/J;
      { Wyznaczanie warunkow poczatkowych wg wzorow (5.210) (5.209) (5.211) }
      X0[3]:=Uw/Rw;
      X0[1]:=(U-w0*MM*X0[3])/(w0*Ls);
      X0[2]:=0;
      X0[4]:=0;
      X0[5]:=0;
      X0[6]:=w0/p;
      X0[7]:=be/p
    END { OBLICZENIA_POMOCNICZE };

   PROCEDURE F(VAR Y:WEK; X:WEK; t:FLOAT;N:BYTE); FAR;
     { Generacja prawej strony ukladu rownan (5.208) }
     VAR teta,s :FLOAT;
         H      :WEK;
         k,l    :BYTE;
     BEGIN
       teta:=w0*t-p*X[7]+be;
       H[1]:=-Rs*X[1]-p*Ls*X[2]*X[6]-p*MM1*X[5]*X[6]-U*SIN(teta);
       H[2]:=-Rs*X[2]+p*Ls*X[1]*X[6]+p*MM*X[3]*X[6]+p*MM1*X[4]*X[6]-
              U*COS(teta);
       H[3]:=-Rw*X[3]+Uw;
       H[4]:=-Rk*X[4];
       H[5]:=-Rk*X[5];
       FOR k:=1 TO 5 DO
       BEGIN
         s:=0;
         FOR l:=1 TO 5 DO s:=s+G[k,l]*H[l];
         Y[k]:=s
       END;
       Y[6]:=-c2*X[6]-c1*X[3]*X[2]-c4*(X[2]*X[4]-X[1]*X[5])+c3*Mnap;
       Y[7]:=X[6]
     END { F };

   PROCEDURE MENU;
     BEGIN
      CLRSCR;
      GOTOXY(1, 5); WRITE('Prezentacja graficzna przebiegow generatora synchronicznego ');
      GOTOXY(1, 7); WRITE(' 1 - prad stojana x1 w ukladzie wspolrzednych wirnika');
      GOTOXY(1, 9); WRITE(' 2 - prad stojana x2 w ukladzie wspolrzednych wirnika');
      GOTOXY(1,11); WRITE(' 3 - prad wzbudzenia wirnika');
      GOTOXY(1,13); WRITE(' 4 - predkosc katowa wirnika');
      GOTOXY(1,15); WRITE(' M - moment elektromagnetyczny generatora');
      GOTOXY(1,17); WRITE(' P - plaszczyzna fazowa pradow stojana');
      GOTOXY(1,19); WRITE(' K - koniec wyboru')
    END { MENU };

BEGIN  {Czesc operacyjna programu}
  INIC_PLIK(N_PLIK);
  t1:=3; N:=7; t0:=0.0;  h0:=(t1-t0)/1000;
  CLRSCR;
  DANE;
  OBLICZENIA_POMOCNICZE;
  WRITE('M= ');
  MET_FEHLB(2,4,N,F,h0,t0,t1,1e-6,1e-9,1E-6,X0,M,N_PLIK,BLAD,10*256+1);
  IF BLAD<>0 THEN
  BEGIN
    PISZ_KOM_BLAD(BLAD);
    HALT
  END;
  CH1:='B';
  ODCZYT_D(X,N,M,CH1,N_PLIK,0,0,BLAD);
  CLRSCR;
  IF BLAD<>0 THEN
  BEGIN
    PISZ_KOM_BLAD(BLAD);
    HALT
  END;
  CH1:='C';
  FOR i:=0 TO M DO
  BEGIN
    ODCZYT_D(X,N,M,CH1,N_PLIK,0,i,BLAD);
    W1[i]:=X*1000;
  END;
  REPEAT
    CLRSCR;
    MENU;
    WYB:=UPCASE(READKEY);
    CASE WYB OF
      '1': BEGIN
             FOR i:=0 TO M DO
               ODCZYT_D(W2[i],N,M,CH1,N_PLIK,1,i,BLAD);
             WYKRESXYG(W1,W2,M,' Przebieg pradu stojana x1 w ukladzie wspolrzednych wirnika ',
                       '','t [msek]','x1(t) [A]')
           END { 1 };
      '2': BEGIN
             FOR i:=0 TO M DO
               ODCZYT_D(W2[i],N,M,CH1,N_PLIK,2,i,BLAD);
             WYKRESXYG(W1,W2,M,' Przebieg pradu stojana x2 w ukladzie wspolrzednych wirnika ',
                       '','t [msek]','x2(t) [A]')
           END { 2 };
      '3': BEGIN
             FOR i:=0 TO M DO
               ODCZYT_D(W2[i],N,M,CH1,N_PLIK,3,i,BLAD);
             WYKRESXYG(W1,W2,M,' Przebieg pradu wzbudzenia ',
                       '','t [msek]','iw(t) [A]')
           END {3};
      '4': BEGIN
             FOR i:=0 TO M DO
             BEGIN
               ODCZYT_D(X,N,M,CH1,N_PLIK,6,i,BLAD);
               W2[i]:=0.5*X/PI;
             END;
             WYKRESXYG(W1,W2,M,' Przebieg predkosci wirnika ',
                       '','t [msek]','w(t) [obr/sek]')
           END {4};
      'M': BEGIN
             FOR i:=0 TO M DO
             BEGIN
               ODCZYT_D(X1,N,M,CH1,N_PLIK,2,i,BLAD);
               ODCZYT_D(X2,N,M,CH1,N_PLIK,3,i,BLAD);
               W2[i]:=p*MM*X1*X2;
               ODCZYT_D(X2,N,M,CH1,N_PLIK,1,i,BLAD);
               ODCZYT_D(X3,N,M,CH1,N_PLIK,5,i,BLAD);
               s:=-X2*X3;
               ODCZYT_D(X2,N,M,CH1,N_PLIK,4,i,BLAD);
               s:=s+X1*X2;
               W2[i]:=W2[i]+p*MM1*s
             END;
             WYKRESXYG(W1,W2,M,' Przebieg momentu elektromagnetycznego'+
                       ' generatora synchronicznego','','t [msek]','M(t) [Nm]')
           END {M};
      'P': BEGIN
             FOR i:=0 TO M DO
             BEGIN
               ODCZYT_D(W3[i],N,M,CH1,N_PLIK,1,i,BLAD);
               ODCZYT_D(W2[i],N,M,CH1,N_PLIK,2,i,BLAD)
             END;
             WYKRESXYG(W3,W2,M,' Plaszczyzna fazowa pradow stojana '+
                       ' generatora synchronicznego','','x1 [A]','x2(t) [A]');
           END {P};

    END
  UNTIL WYB='K';
  CH1:='E';
  ODCZYT_D(X1,N,M,CH1,N_PLIK,0,0,BLAD)
END.



