PROGRAM PRZ5_7;
  {$M 50000,0,600000}
  {$IFDEF CPU87} {$N+}
         {$ELSE} {$N-}
  {$ENDIF}
  USES CRT,GRAPH,TFLOAT,ALGELIN,RORONLP,WYKRESY,PLIK_ZO,KOM_BLAD;
  VAR  X,X1,X2                                 :FLOAT;
       X0                                      :WEK;
       W1,W2,W3                                :WEKI;
       M,i,M1                                  :WORD;
       N,sk                                    :BYTE;
       h,h0,t0,t1,t,R0,fi,beta,L0,Em,w,w0,C1,
       imax,alfamax,alfa0                      :FLOAT;
       WYB,CHN,CH1,CH                          :CHAR;
       N_PLIK                                  :DANE_NAZWY_PLIKU;
       BLAD                                    :BYTE;

  PROCEDURE DANE;
    BEGIN
      R0:=100 {om};  w:=100*PI {1/sek}; L0:=100/w {H};
      Em:=220*SQRT(2) {V}; fi:=PI/3;
      w0:=3 {1/sek}; beta:=0.5;  alfamax:=1 {rad};
      alfa0:=0.15*alfamax;  imax:=4 {A};
      C1:=alfamax*(alfa0+alfamax)/SQR(imax); { wzor (5.246) }
      t1:=2; N:=3 ; t0:=0.0;  h0:=(t1-t0)/512;
      X0[1]:=0.0; X0[2]:=0.0; X0[3]:=0.0;
    END {DANE};

   FUNCTION E(t:FLOAT):FLOAT;
     VAR  A:FLOAT;
     BEGIN
       E:=Em*SIN(w*t+fi)
     END {E};

   PROCEDURE G(VAR F:WEK; X:WEK; t:FLOAT;N:BYTE); FAR;
   { Prawa strona ukladu rownan (5.250) }
     BEGIN
       F[1]:=X[2];
       F[2]:=-2*beta*w0*X[2]+SQR(w0)*(-X[1]+C1*SQR(X[3])/(alfa0+X[1]));
       F[3]:=(-R0*X[3]+E(t))/L0;
     END {G};

   PROCEDURE MENU2;
     BEGIN
       CLRSCR;
       GOTOXY(1, 5); WRITE('Wywolywanie sygnalu wyjscioergo danej galezi');
       GOTOXY(5, 7); WRITE(' I - pradu zasilania odbiornika;');
       GOTOXY(5, 9); WRITE(' A - kat wychylenia wskazowki przyrzadu elektromagnetycznego');
       GOTOXY(5,11); WRITE(' W - predkosc katowa wskazowki ');
       GOTOXY(5,13); WRITE(' P - plaszczyzna fazowa ');
       GOTOXY(5,17); WRITE(' K - koniec wyboru')
     END { MENU2 };

   PROCEDURE MENU1;
     BEGIN
      CLRSCR;
      GOTOXY(8, 5);WRITE('        Wybor metody: ');
      GOTOXY(8, 7);WRITE('klawisz  R - Rungego-Kutty;');
      GOTOXY(8, 9);WRITE('         F - Fehlberga');
      GOTOXY(8,11);WRITE('         W - wielokrokowa');
      GOTOXY(8,13);WRITE('         G - Geara');
      GOTOXY(8,17);WRITE('         S - koniec wyboru')
    END { MENU1 };


BEGIN  {Czesc operacyjna programu}
  REPEAT
    INIC_PLIK(N_PLIK);
    MENU1;
    CHN:=UPCASE(READKEY);
    CLRSCR;
    IF CHN in ['R','F','W','G'] THEN
    BEGIN
      DANE;
      GOTOXY(1,20); WRITE('M= ');
      CASE CHN OF
        'R' : MET_RUN_KUT(2,4,N,G,h0,t0,t1,1E-4,1E-10,1E-5,X0,M,N_PLIK,BLAD,10*256+20);
        'F' : MET_FEHLB(2,4,N,G,h0,t0,t1,1e-5,1e-10,1E-5,X0,M,N_PLIK,BLAD,10*256+20);
        'W' : MET_ADAMS_MUL(2,N,G,h0,t0,t1,1e-5,1e-10,1E-5,X0,M,N_PLIK,BLAD,10*256+20);
        'G' : MET_GEAR(2,N,G,h0,t0,t1,1e-5,1e-10,1E-5,X0,M,N_PLIK,BLAD,10*256+20)
      END;
      IF BLAD<>0 THEN
      BEGIN
        PISZ_KOM_BLAD(BLAD);
        HALT
      END;
      CH1:='B';
      ODCZYT_D(X,N,M,CH1,N_PLIK,0,0,BLAD);
      IF BLAD<>0 THEN
      BEGIN
        PISZ_KOM_BLAD(BLAD);
        HALT
      END;
      sk:=1+TRUNC(M/1024); M1:=TRUNC(M/sk);
      CH1:='C';
      FOR i:=0 TO M1 DO
        ODCZYT_D(W1[i],N,M,CH1,N_PLIK,0,sk*i,BLAD);
      REPEAT
        CLRSCR;
        MENU2;
        WYB:=UPCASE(READKEY);
        CASE WYB OF
          'I': BEGIN
                 FOR i:=0 TO M1 DO
                   ODCZYT_D(W2[i],N,M,CH1,N_PLIK,3,sk*i,BLAD);
                 WYKRESXYG(W1,W2,M1,'Przebieg pradu zasilania ','','t [sek]','i(t) [A]')
               END { I };
          'A': BEGIN
                 FOR i:=0 TO M1 DO
                   ODCZYT_D(W2[i],N,M,CH1,N_PLIK,1,sk*i,BLAD);
                 WYKRESXYG(W1,W2,M1,'Przebieg kata wychylenia wskazowki  ',
                           ' ','t [sek]','alfa(t) [rad]')
               END { A };
          'W': BEGIN
                 FOR i:=0 TO M1 DO
                   ODCZYT_D(W2[i],N,M,CH1,N_PLIK,2,sk*i,BLAD);
                 WYKRESXYG(W1,W2,M1,'Przebieg predkosci katowej wskazowki  ',
                           ' ','t [sek]','w(t) [rad/sek]')
               END { W };
          'P': BEGIN
                 FOR i:=0 TO M1 DO
                 BEGIN
                   ODCZYT_D(W3[i],N,M,CH1,N_PLIK,1,sk*i,BLAD);
                   ODCZYT_D(W2[i],N,M,CH1,N_PLIK,2,sk*i,BLAD);
                 END;
                 WYKRESXYG(W3,W2,M1,' Plaszczyzna fazowa stanu nieustalonego przyrzadu'+
                           ' elektromagnetycznego','','alf(t) [rad]','d alf(t)/dt [rad/sek]')
               END { P };
        END
      UNTIL WYB='K';
      CH1:='E';
      ODCZYT_D(X1,N,M,CH1,N_PLIK,0,0,BLAD)
    END
  UNTIL CHN='S'
END.
