PROGRAM PRZ6_1;
  {$M 50000,0,600000}
  {$IFDEF CPU87} {$N+}
         {$ELSE} {$N-}
  {$ENDIF}
  USES CRT,GRAPH,TFLOAT,ALGELIN,ROROLID,WYKRESY,KOM_BLAD;
  VAR  X0        :WEK;
       A,B       :MAC;
       W0,W1,W2  :WEKI;
       M,M1,i    :WORD;
       N,W       :BYTE;
       T,t0,t1,R,R1,R2,L1,L2,E,I10,I11,I12,I20,I21,I22,
       a0,a1,a2,s1,s2,s0,IA,DI1,DI2,X,X1,X2:FLOAT;
       WYB,CH,CH1:CHAR;
       XX        :MACD3;
       BLAD      :BYTE;

  PROCEDURE DANE;
    BEGIN
      t1:=0.02; ;M1:=512;   t0:=0.0;  T:=(t1-t0)/M1;
      N:=2; W:=1;
      R1:=1; R2:=1; R:=0.2; L1:=0.1; L2:=0.001; E:=10;
      X0[1]:=0.0; X0[2]:=0.0;
    END {DANE};

   PROCEDURE POMOC;
     VAR DELTA,MP:FLOAT;
     BEGIN
       { Obliczanie wyrazen (6.61) }
       a0:=R1*R2+R*R1+R*R2;
       a1:=L1*R2+L2*R1+R*L1+R*L2;
       a2:=L1*L2;
       { Wyznaczanie polozenia biegunow s1,s2 wzory (6.63) }
       DELTA:=SQR(a1)-4*a2*a0; DELTA:=SQRT(DELTA);
       s1:=0.5*(-a1+DELTA)/a2; s2:=0.5*(-a1-DELTA)/a2; s0:=0;
       { Obliczanie wspolczynnikow we wzorach (6.62) }
       MP:=s1*(2*a2*s1+a1);
       I11:=E*(s1*L2+R2)/MP;  I21:=E*(s1*L1+R1)/MP;
       MP:=s2*(2*a2*s2+a1);
       I12:=E*(s2*L2+R2)/MP;  I22:=E*(s2*L1+R1)/MP;
       I10:=E*R2/a0;  I20:=E*R1/a0;
     END {POMOC};

   FUNCTION I1(t:FLOAT):FLOAT; { wg wzoru (6.62a) }
     BEGIN
       I1:=I11*EXP(s1*t)+I12*EXP(s2*t)+I10
     END {I1};

   FUNCTION I2(t:FLOAT):FLOAT; { wg wzoru (6.62b) }
     BEGIN
       I2:=I21*EXP(s1*t)+I22*EXP(s2*t)+I20
     END {I2};

  PROCEDURE GENMACAIB;
{ Generacja macierzy A i B w ukladzie rownan rozniczkowych (6.59) }
    VAR i,j:BYTE;
    BEGIN
      A[1,1]:=-(R+R1)/L1; A[1,2]:=-R/L1;
      A[2,1]:=-R/L2; A[2,2]:=-(R+R2)/L2;
      B[1,1]:=1/L1; B[2,1]:=1/L2;
    END;

  PROCEDURE WU(VAR U:WEK;t:FLOAT;W:BYTE); FAR;
{ Konstrukcja funkcji wymuszajacej w ukladzie rownan (6.59) }
    BEGIN
      U[1]:=E
    END;

   PROCEDURE MENU1;
     BEGIN
      CLRSCR;
      GOTOXY(1, 5);WRITE('     Wybor metody:');
      GOTOXY(5, 7);WRITE('klawisz  1 - RURRLIN');
      GOTOXY(5, 9);WRITE('         2 - metoda Fehlberga');
      GOTOXY(5,11);WRITE('         3 - metoda Geara');
      GOTOXY(5,13);WRITE('         S - koniec wyboru')
    END { MENU1 };

   PROCEDURE MENU2;
     BEGIN
      CLRSCR;
      GOTOXY(1, 5);WRITE('     Przebiegi pradow danej galezi');
      GOTOXY(5, 7);WRITE('klawisz  A - prad i1 ze wzoru (6.62a)');
      GOTOXY(5, 9);WRITE('         B - prad i2 ze wzoru (6.62b)');
      GOTOXY(5,11);WRITE('         D - prad i1 z rozwiazania row.(6.59)');
      GOTOXY(5,13);WRITE('         E - prad i2 z rozwiazania row.(6.59)');
      GOTOXY(5,15);WRITE('         W - porownanie rozwiazan row.(6.59) ze wzorem (6.62)');
      GOTOXY(5,17);WRITE('         K - koniec wyboru')
    END { MENU2 };

  BEGIN  {Czesc operacyjna programu}
    REPEAT
      MENU1;
      CH1:=UPCASE(READKEY);
      IF CH1 in ['1','2','3'] THEN
      BEGIN
        DANE;
        POMOC;
        GENMACAIB;
        CASE CH1 OF
          '1': RURRLIN(3,WU,A,B,N,W,T,t0,t1,1E-8,1E-4,X0,M,XX,BLAD,0);
          '2': MET_FEHLB_LIN(2,4,N,W,WU,A,B,T,t0,t1,1E-6,1E-10,1E-6,X0,M,XX,BLAD,0);
          '3': MET_GEAR_LIN(2,N,W,WU,A,B,T,t0,t1,1E-6,1E-10,1E-6,X0,M,XX,BLAD,0)
        END;
        IF BLAD<>0
          THEN BEGIN
                 PISZ_KOM_BLAD(BLAD);
                 CH:=READKEY
               END
          ELSE BEGIN
                 IF M>1024
                   THEN M1:=1024
                   ELSE M1:=M;
                 FOR i:=0 TO M1 DO
                   W1[i]:=XX[i]^[0]*1000;
                 REPEAT
                   CLRSCR;
                   MENU2;
                   WYB:=UPCASE(READKEY);
                   CASE WYB OF
                     'D': BEGIN
                            FOR i:=0 TO M1 DO
                              W2[i]:=XX[i]^[1];
                      { Procedure WYKRESXYG z modulu WYKRESY patrz zalacznik1 }
                            WYKRESXYG(W1,W2,M1,'Rys.1 Przebieg pradu i1 ','','t [msek]','i1(t) [A]')
                          END { I };
                     'E': BEGIN
                            FOR i:=0 TO M1 DO
                              W2[i]:=XX[i]^[2];
                            WYKRESXYG(W1,W2,M1,'Rys.2 Przebieg pradu i2 ','','t [msek]','i2(t) [A]')
                          END { U };
                     'A': BEGIN
                             FOR i:=0 TO M1 DO
                               W2[i]:=I1(W1[i]/1000);
                             WYKRESXYG(W1,W2,M1,'Rys.3 Przebieg pradu i1 ','','t [msek]','i1(t) [A]')
                          END {A};
                     'B': BEGIN
                            FOR i:=0 TO M1 DO
                              W2[i]:=I2(W1[i]/1000);
                            WYKRESXYG(W1,W2,M1,'Rys.4 Przebieg pradu i2 ','','t [msek]','i1(t) [A]')
                          END {B};
                     'W': BEGIN
                            CLRSCR;
                            WRITELN('t':9,'i1(t)':15,'i2(t)':13,'i1(t)':14,'i2(t)':13);
                            FOR i:=1 TO M1 DO
                            BEGIN
                              X1:=XX[i]^[1];
                              X2:=XX[i]^[2];
                              t:=W1[i]/1000;  IA:=I1(t); DI1:=(IA-X1)/IA;
                              IA:=I2(t); DI2:=(IA-X2)/IA;
                              WRITELN(W1[i]:13:8,X1:13:8,X2:13:8,'   ',DI1:10,'   ',DI2:10);
                              IF FRAC((i)/23)=0 THEN
                              BEGIN
                                CH:=READKEY;
                                CLRSCR;
                                WRITELN('t':9,'i1(t)':15,'i2(t)':13,'i1(t)':14,'i2(t)':13)
                              END
                            END;
                            WRITELN(#7);
                            CH:=READKEY
                          END {E}
                   END
                 UNTIL WYB='K'
               END;
        DISMACD3(XX,M)
      END
    UNTIL CH1='S'
  END.



