PROGRAM PRZ6_2;
  {$M 50000,0,600000}
  {$IFDEF CPU87} {$N+}
         {$ELSE} {$N-}
  {$ENDIF}
  USES CRT,GRAPH,TFLOAT,ALGELIN,ROROLIP,WYKRESY,PLIK_ZO,KOM_BLAD;
  VAR  X0         :WEK;
       A,B        :MAC;
       W0,W1,W2   :WEKI;
       M,M1,i     :WORD;
       SK,N,W     :BYTE;
       T,t0,t1,R1,L1,C2,R3,L3,fi,omega,omegar,Em,X,X1,X2:FLOAT;
       WYB,CH,CH1 :CHAR;
       N_PLIK     :DANE_NAZWY_PLIKU;
       BLAD       :BYTE;

  PROCEDURE DANE;
    BEGIN
      t1:=0.04; ;M1:=512;   t0:=0.0;  T:=(t1-t0)/(10*M1);
      N:=3; W:=1;
      Em:=220*SQRT(2); {V} fi:=PI/4; {rad} omega:=100*PI; {rad/sek}
      R3:=50; {OM} L3:=50/omega; {H}
      R1:=2.5; {OM} L1:=2.5/omega; {H}
      omegar:=500*PI; {rad/sek} C2:=1/(SQR(omegar)*L1); {F}
      X0[1]:=0.0; X0[2]:=0.0;X0[3]:=0.0;
    END { DANE };

  PROCEDURE GENMACAIB;
  { Generacja macierzy w ukladzie rownan (6.65) }
    BEGIN
      MACZERO(A,N,N);
      MACZERO(B,N,W);
      A[1,1]:=-R1/L1; A[1,3]:=-1/L1;
      A[2,2]:=-R3/L3; A[2,3]:=1/L3;
      A[3,1]:=1/C2;   A[3,2]:=-1/C2;
      B[1,1]:=1/L1;
    END;

  PROCEDURE WU(VAR U:WEK;t:FLOAT;W:BYTE); FAR;
  { Konstrukcja wymuszenia ukladu rownan (6.65) }
    BEGIN
      U[1]:=Em*SIN(omega*t+fi)
    END;

   PROCEDURE MENU1;
     BEGIN
       CLRSCR;
       GOTOXY(1, 9);WRITE('     Wybor metody:');
       GOTOXY(5,11);WRITE('klawisz  1 - RURRLIN');
       GOTOXY(5,13);WRITE('         2 - metoda Fehlberga');
       GOTOXY(5,15);WRITE('         3 - metoda Geara');
       GOTOXY(5,17);WRITE('         S - koniec wyboru')
     END { MENU1 };

   PROCEDURE MENU2;
     BEGIN
       CLRSCR;
       GOTOXY(1, 5);WRITE('Wywolywanie przebiegow wielkosci chwilowych');
       GOTOXY(5, 7);WRITE('klawisz  P - prad zasilania ukladu i1 ');
       GOTOXY(5, 9);WRITE('         O - prad obciazenia ukladu i3 ');
       GOTOXY(5,11);WRITE('         C - napiecie na kondensatorze u2 ');
       GOTOXY(5,19);WRITE('         K - koniec wyboru')
     END { MENU2 };

  BEGIN  {Czesc operacyjna programu}
    INIC_PLIK(N_PLIK);
    REPEAT
      MENU1;
      CH1:=UPCASE(READKEY);
      IF CH1 in ['1','2','3'] THEN
      BEGIN
        DANE;
        GENMACAIB;
        GOTOXY(1,1); WRITE('M=');
        CASE CH1 OF
          '1': RURRLIN(2,WU,A,B,N,W,T,t0,t1,1E-6,1E-4,X0,M,N_PLIK,BLAD,10*256+1);
          '2': MET_FEHLB_LIN(2,4,N,W,WU,A,B,T,t0,t1,1E-6,1E-10,1E-6,X0,M,N_PLIK,BLAD,10*256+1);
          '3': MET_GEAR_LIN(2,N,W,WU,A,B,T,t0,t1,1E-6,1E-10,1E-6,X0,M,N_PLIK,BLAD,10*256+1)
        END;
        IF BLAD<>0
          THEN BEGIN
                 PISZ_KOM_BLAD(BLAD);
                 CH:=READKEY
               END
          ELSE BEGIN
                 IF BLAD<>0 THEN
                 BEGIN
                   PISZ_KOM_BLAD(BLAD);
                   HALT
                 END;
                 ODCZYT_D(X,N,M,'B',N_PLIK,0,0,BLAD);
                 IF BLAD<>0 THEN
                 BEGIN
                   PISZ_KOM_BLAD(BLAD);
                   HALT
                 END;
                 IF M>1024
                   THEN BEGIN
                          M1:=1024;
                          SK:=TRUNC(M/M1);
                        END
                   ELSE BEGIN
                          M1:=M;
                          SK:=1
                        END;
                 FOR i:=0 TO M1 DO
                 BEGIN
                   ODCZYT_D(X,N,M,'C',N_PLIK,0,SK*i,BLAD);
                   W1[i]:=X*1000
                 END;
                 REPEAT
                   CLRSCR;
                   MENU2;
                   WYB:=UPCASE(READKEY);
                   CASE WYB OF
                     'P': BEGIN
                            FOR i:=0 TO M1 DO
                              ODCZYT_D(W2[i],N,M,'C',N_PLIK,1,SK*i,BLAD);
                            WYKRESXYG(W1,W2,M1,'Rys.1 Przebieg pradu ukladu i1 ','','t [msek]','i1(t) [A]')
                          END { P };
                     'O': BEGIN
                            FOR i:=0 TO M1 DO
                              ODCZYT_D(W2[i],N,M,'C',N_PLIK,2,SK*i,BLAD);
                            WYKRESXYG(W1,W2,M1,'Rys.2 Przebieg pradu odbiornika i3 ','','t [msek]','i3(t) [A]')
                          END { O };
                     'C': BEGIN
                            FOR i:=0 TO M1 DO
                              ODCZYT_D(W2[i],N,M,'C',N_PLIK,3,SK*i,BLAD);
                            WYKRESXYG(W1,W2,M1,'Rys.3 Przebieg napiecia na kondensatorze u2 ','','t [msek]','u2(t) [V]')
                          END { C };
                   END
                 UNTIL WYB='K';
                 ODCZYT_D(X1,N,M,'E',N_PLIK,0,0,BLAD)
               END;
      END
    UNTIL CH1='S'
  END.



